﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI '

	Private bxtTableCustomer As B4XTable
	Private ToastMessage As BCToast

	Private btnAdd, btnEdit, btnFilter, btnSetFilter As B4XView
	Private lblSelectedItem As B4XView

	Public RowIDListCustomer As List		'list containing the rowids of the database
	Public CurrentIndexCustomer = -1 As Int		' index of the current entry
	
	#Region Drawer
	Private Drawer As B4XDrawer
	Private HamburgerIcon As B4XBitmap
	Private btnCustomer As B4XView
	Private btnEmployee As B4XView
	#End Region

End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("Customer")
	ToastMessage.Initialize(Root)

	#Region Drawer
	Drawer.Initialize(Me, "Drawer", Root, 200dip)
	Drawer.CenterPanel.LoadLayout("Customer")
	Drawer.LeftPanel.LoadLayout("drawer")
	HamburgerIcon = xui.LoadBitmapResize(File.DirAssets, "hamburger.png", 32dip, 32dip, True)
	#if B4i
	Dim bb As BarButton
	bb.InitializeBitmap(HamburgerIcon, "hamburger")
	B4XPages.GetNativeParent(Me).TopLeftButtons = Array(bb)
	#Else If B4J
	Dim iv As ImageView
	iv.Initialize("imgHamburger")
	iv.SetImage(HamburgerIcon)
	Drawer.CenterPanel.AddView(iv, 2dip, 2dip, 32dip, 32dip)
	iv.PickOnBounds = True
	#end if
	btnCustomer.Enabled = False
	#End Region
	
	InitTable

	
End Sub

Private Sub B4XPage_Appear
	ShowTableCustomer
End Sub

Private Sub bxtTableCustomer_CellClicked (ColumnId As String, RowId As Long)
	CurrentIndexCustomer = RowId - 1
	'UpdateSelectedEntryDisplay
End Sub

Private Sub btnEdit_Click
	Main.ModeCustomer = "Edit"
	
	B4XPages.ShowPage("CustomerEdit")
End Sub

Private Sub btnAdd_Click
	Main.ModeCustomer = "Add"
	
	B4XPages.ShowPage("CustomerEdit")
End Sub

'Shows the database in a table in a B4XTable
Public Sub ShowTableCustomer
	Private Query As String

	ReadDataBaseRowIDs
	
	Query = "SELECT Name, Description, Adress1, Adress2, Adress3, Street, Town FROM customers"
	'depending if the filter is active or not we add the filter query at the end of the query
	'the filter query is defined in the Filter Activity
	'If Filter.flagFilterActive = False Then
	'btnFilter.Text = "Filter"
	'Else
	'	btnFilter.Text = "UnFilter"
	'	Query = Query & Filter.Query
	'End If

	Dim Data As List
	Data.Initialize
	Dim rs As ResultSet = B4XPages.MainPage.SQL1.ExecQuery(Query)
	Do While rs.NextRow
		Dim row(7) As Object
		row(0) = rs.GetString("Name")
		row(1) = rs.GetString("Description")
		row(2) = rs.GetString("Adress1")
		row(3) = rs.GetString("Adress2")
		row(4) = rs.GetString("Adress3")
		row(5) = rs.GetString("Street")
		row(6) = rs.GetString("Town")
		Data.Add(row)
	Loop
	rs.Close
	bxtTableCustomer.SetData(Data)
	
	'UpdateSelectedEntryDisplay
End Sub

'Reads the database rowids in RowIDList
Private Sub ReadDataBaseRowIDs
	Private ResultSet1 As ResultSet
	
	'If Filter.flagFilterActive = False Then
	ResultSet1 = B4XPages.MainPage.SQL1.ExecQuery("SELECT rowid FROM customers")
	'Else
	'	ResultSet1 = B4XPages.MainPage.SQL1.ExecQuery("SELECT rowid FROM persons"  & Filter.Query)
	'End If
	
	'We read only the rowid column and put them in the IDList
	RowIDListCustomer.Initialize				'initialize the ID list
	Do While ResultSet1.NextRow
		RowIDListCustomer.Add(ResultSet1.GetInt2(0))		'add the ID's to the ID list
	Loop
	
	If RowIDListCustomer.Size > 0 Then
		If CurrentIndexCustomer = -1 Or CurrentIndexCustomer > RowIDListCustomer.Size - 1 Then
			CurrentIndexCustomer = 0			'set the current index to 0
		End If
	Else
		CurrentIndexCustomer = -1			'set the current index to -1, no selected item
		ToastMessage.Show("No items found")
	End If
	ResultSet1.Close							'close the ResultSet, we don't need it anymore
End Sub

Private Sub InitTable
	bxtTableCustomer.AddColumn("Name", bxtTableCustomer.COLUMN_TYPE_TEXT)
	bxtTableCustomer.AddColumn("Description", bxtTableCustomer.COLUMN_TYPE_TEXT)
	bxtTableCustomer.AddColumn("Adress1", bxtTableCustomer.COLUMN_TYPE_TEXT)
	bxtTableCustomer.AddColumn("Adress2", bxtTableCustomer.COLUMN_TYPE_TEXT)
	bxtTableCustomer.AddColumn("Adress3", bxtTableCustomer.COLUMN_TYPE_TEXT)
	bxtTableCustomer.AddColumn("Street", bxtTableCustomer.COLUMN_TYPE_TEXT)
	bxtTableCustomer.AddColumn("Town", bxtTableCustomer.COLUMN_TYPE_TEXT)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.