﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private bxtTableEmployee As B4XTable
	Private ToastMessage As BCToast
	Public Edit As B4XEmployeeEdit

	Private btnAdd, btnEdit, btnFilter, btnSetFilter As B4XView
	Private lblSelectedItem As B4XView
	Public RowIDListEmployee As List		'list containing the rowids of the database
	Public CurrentIndexEmployee = -1 As Int		' index of the current entry


	#Region Drawer
	Private Drawer As B4XDrawer
	Private HamburgerIcon As B4XBitmap
	Private btnCustomer As B4XView
	Private btnEmployee As B4XView
	#End Region

End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("Employee")
	ToastMessage.Initialize(Root)

	#Region Drawer
	Drawer.Initialize(Me, "Drawer", Root, 200dip)
	Drawer.CenterPanel.LoadLayout("Employee")
	Drawer.LeftPanel.LoadLayout("drawer")
	HamburgerIcon = xui.LoadBitmapResize(File.DirAssets, "hamburger.png", 32dip, 32dip, True)
	#if B4i
	Dim bb As BarButton
	bb.InitializeBitmap(HamburgerIcon, "hamburger")
	B4XPages.GetNativeParent(Me).TopLeftButtons = Array(bb)
	#Else If B4J
	Dim iv As ImageView
	iv.Initialize("imgHamburger")
	iv.SetImage(HamburgerIcon)
	Drawer.CenterPanel.AddView(iv, 2dip, 2dip, 32dip, 32dip)
	iv.PickOnBounds = True
	#end if
	btnEmployee.Enabled = False
	#End Region

	InitTable
	
End Sub

Private Sub B4XPage_Appear
	ShowTableEmployee
End Sub

#if B4J
Sub imgHamburger_MouseClicked (EventData As MouseEvent)
	Drawer.LeftOpen = True
End Sub
#else if B4i
Private Sub B4XPage_MenuClick (Tag As String)
	If Tag = "hamburger" Then
		Drawer.LeftOpen = Not(Drawer.LeftOpen)
	End If
End Sub
#end if

Private Sub btnEdit_Click
	Main.ModeEmployee = "Edit"
	
	B4XPages.ShowPage("EmployeeEdit")
End Sub

Private Sub btnAdd_Click
	Main.ModeEmployee = "Add"
	
	B4XPages.ShowPage("EmployeeEdit")
End Sub


Private Sub bxtTableEmployee_CellClicked (ColumnId As String, RowId As Long)
	CurrentIndexEmployee = RowId - 1
	UpdateSelectedEntryDisplay
End Sub

'Shows the database in a table in a B4XTable
Public Sub ShowTableEmployee
	Private Query As String

	ReadDataBaseRowIDs
	
	Query = "SELECT Firstname, Lastname, City FROM persons"
	'depending if the filter is active or not we add the filter query at the end of the query
	'the filter query is defined in the Filter Activity
	'If Filter.flagFilterActive = False Then
		btnFilter.Text = "Filter"
	'Else
	'	btnFilter.Text = "UnFilter"
	'	Query = Query & Filter.Query
	'End If

	Dim Data As List
	Data.Initialize
	Dim rs As ResultSet = B4XPages.MainPage.SQL1.ExecQuery(Query)
	Do While rs.NextRow
		Dim row(3) As Object
		row(0) = rs.GetString("Firstname")
		row(1) = rs.GetString("Lastname")
		row(2) = rs.GetString("City")
		Data.Add(row)
	Loop
	rs.Close
	bxtTableEmployee.SetData(Data)
	
	UpdateSelectedEntryDisplay
End Sub

'Reads the database rowids in RowIDList
Private Sub ReadDataBaseRowIDs
	Private ResultSet1 As ResultSet
	
	'If Filter.flagFilterActive = False Then
		ResultSet1 = B4XPages.MainPage.SQL1.ExecQuery("SELECT rowid FROM persons")
	'Else
	'	ResultSet1 = B4XPages.MainPage.SQL1.ExecQuery("SELECT rowid FROM persons"  & Filter.Query)
	'End If
	
	'We read only the rowid column and put them in the IDList
	RowIDListEmployee.Initialize				'initialize the ID list
	Do While ResultSet1.NextRow
		RowIDListEmployee.Add(ResultSet1.GetInt2(0))		'add the ID's to the ID list
	Loop
	
	If RowIDListEmployee.Size > 0 Then
		If CurrentIndexEmployee = -1 Or CurrentIndexEmployee > RowIDListEmployee.Size - 1 Then
			CurrentIndexEmployee = 0			'set the current index to 0
		End If
	Else
		CurrentIndexEmployee = -1			'set the current index to -1, no selected item
		ToastMessage.Show("No items found")
	End If
	ResultSet1.Close							'close the ResultSet, we don't need it anymore
End Sub

Public Sub UpdateSelectedEntryDisplay
	If CurrentIndexEmployee > -1 Then
		Private Query As String
		Private ResultSet1 As ResultSet
	
		Query = "SELECT FirstName, LastName FROM persons WHERE rowid = " & RowIDListEmployee.Get(CurrentIndexEmployee)
		ResultSet1 = B4XPages.MainPage.SQL1.ExecQuery(Query)
		ResultSet1.NextRow
		lblSelectedItem.Text = ResultSet1.GetString("FirstName") & " " & ResultSet1.GetString("LastName")
		ResultSet1.Close
	Else
		lblSelectedItem.Text = ""
	End If
End Sub

Private Sub InitTable
	bxtTableEmployee.AddColumn("Firstname", bxtTableEmployee.COLUMN_TYPE_TEXT)
	bxtTableEmployee.AddColumn("Lastname", bxtTableEmployee.COLUMN_TYPE_TEXT)
	bxtTableEmployee.AddColumn("City", bxtTableEmployee.COLUMN_TYPE_TEXT)
End Sub


'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.