﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private bxtTableJob As B4XTable
	Private ToastMessage As BCToast
	Public RowIDListJob As List		'list containing the rowids of the database
	Public CurrentIndexJob = -1 As Int		' index of the current entry

	#Region Drawer
	Private Drawer As B4XDrawer
	Private HamburgerIcon As B4XBitmap
	Private btnJob As B4XView
	#End Region

End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("Job")
	ToastMessage.Initialize(Root)

	#Region Drawer
	Drawer.Initialize(Me, "Drawer", Root, 200dip)
	Drawer.CenterPanel.LoadLayout("Job")
	Drawer.LeftPanel.LoadLayout("drawer")
	HamburgerIcon = xui.LoadBitmapResize(File.DirAssets, "hamburger.png", 32dip, 32dip, True)
	#if B4i
	Dim bb As BarButton
	bb.InitializeBitmap(HamburgerIcon, "hamburger")
	B4XPages.GetNativeParent(Me).TopLeftButtons = Array(bb)
	#Else If B4J
	Dim iv As ImageView
	iv.Initialize("imgHamburger")
	iv.SetImage(HamburgerIcon)
	Drawer.CenterPanel.AddView(iv, 2dip, 2dip, 32dip, 32dip)
	iv.PickOnBounds = True
	#end if
	btnJob.Enabled = False
	#End Region

	InitTable
	
End Sub

Private Sub B4XPage_Appear
	ShowTableJob
End Sub

'Shows the database in a table in a B4XTable
Public Sub ShowTableJob
	Private Query As String

	ReadDataBaseRowIDs
	
	Query = "SELECT jobname, startdate, enddate, customer FROM jobs"
	'depending if the filter is active or not we add the filter query at the end of the query
	'the filter query is defined in the Filter Activity
	'If Filter.flagFilterActive = False Then
	'btnFilter.Text = "Filter"
	'Else
	'	btnFilter.Text = "UnFilter"
	'	Query = Query & Filter.Query
	'End If

	Dim Data As List
	Data.Initialize
	Dim rs As ResultSet = B4XPages.MainPage.SQL1.ExecQuery(Query)
	Do While rs.NextRow
		Dim row(4) As Object
		row(0) = rs.GetString("jobname")
		row(1) = rs.GetString("startdate")
		row(2) = rs.GetString("enddate")
		row(3) = rs.GetString("customer")
		Data.Add(row)
	Loop
	rs.Close
	bxtTableJob.SetData(Data)
	
	'UpdateSelectedEntryDisplay
End Sub

'Reads the database rowids in RowIDList
Private Sub ReadDataBaseRowIDs
	Private ResultSet1 As ResultSet
	
	'If Filter.flagFilterActive = False Then
	ResultSet1 = B4XPages.MainPage.SQL1.ExecQuery("SELECT rowid FROM jobs")
	'Else
	'	ResultSet1 = B4XPages.MainPage.SQL1.ExecQuery("SELECT rowid FROM persons"  & Filter.Query)
	'End If
	
	'We read only the rowid column and put them in the IDList
	RowIDListJob.Initialize				'initialize the ID list
	Do While ResultSet1.NextRow
		RowIDListJob.Add(ResultSet1.GetInt2(0))		'add the ID's to the ID list
	Loop
	
	If RowIDListJob.Size > 0 Then
		If CurrentIndexJob = -1 Or CurrentIndexJob > RowIDListJob.Size - 1 Then
			CurrentIndexJob = 0			'set the current index to 0
		End If
	Else
		CurrentIndexJob = -1			'set the current index to -1, no selected item
		ToastMessage.Show("No items found")
	End If
	ResultSet1.Close							'close the ResultSet, we don't need it anymore
End Sub

Private Sub InitTable
	bxtTableJob.AddColumn("Jobname", bxtTableJob.COLUMN_TYPE_TEXT)
	bxtTableJob.AddColumn("Startdate", bxtTableJob.COLUMN_TYPE_NUMBERS)
	bxtTableJob.AddColumn("Enddate", bxtTableJob.COLUMN_TYPE_NUMBERS)
	bxtTableJob.AddColumn("Customer", bxtTableJob.COLUMN_TYPE_TEXT)
End Sub
'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.