﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.9
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=B4XPagesSQLiteLight2.zip

Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Public MP As B4XMainPage
	Public Filter As PageFilter

	Public Employee As B4XEmployeePage
	Public EmployeeEdit As B4XEmployeeEdit

	Public Customer As B4XCustomerPage
	Public CustomerEdit As B4XCustomerEdit

	Public Job As B4XJobPage

	
	Public SQL1 As SQL
	Public CurrentIndex = -1 As Int		' index of the current entry
	Public RowIDList As List					'list containing the rowids of the database
	
	Private bxtTable As B4XTable
	Private ToastMessage As BCToast
	
	Private btnAdd, btnEdit, btnFilter, btnSetFilter As B4XView
	Private lblSelectedItem As B4XView
	
	#Region Drawer
	Private Drawer As B4XDrawer
	Private HamburgerIcon As B4XBitmap
	Private btnCustomer As B4XView
	Private btnEmployee As B4XView
	#End Region
	
End Sub

'You can add more parameters here.
Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	
	'load the layout to Root
	Root.LoadLayout("Main")
	MP = B4XPages.MainPage
	
	'initialize the Pages
	Employee.Initialize
	B4XPages.AddPage("Employee", Employee)
	EmployeeEdit.Initialize
	B4XPages.AddPage("EmployeeEdit", EmployeeEdit)

	Customer.Initialize
	B4XPages.AddPage("Customer", Customer)
	CustomerEdit.Initialize
	B4XPages.AddPage("CustomerEdit", CustomerEdit)

	Job.Initialize
	B4XPages.AddPage("Job", Job)
	
	Filter.Initialize
	B4XPages.AddPage("Filter", Filter)

	#Region Drawer
	Drawer.Initialize(Me, "Drawer", Root, 200dip)
	Drawer.CenterPanel.LoadLayout("Main")
	Drawer.LeftPanel.LoadLayout("drawer")
	HamburgerIcon = xui.LoadBitmapResize(File.DirAssets, "hamburger.png", 32dip, 32dip, True)
	#if B4i
	Dim bb As BarButton
	bb.InitializeBitmap(HamburgerIcon, "hamburger")
	B4XPages.GetNativeParent(Me).TopLeftButtons = Array(bb)
	#Else If B4J
	Dim iv As ImageView
	iv.Initialize("imgHamburger")
	iv.SetImage(HamburgerIcon)
	Drawer.CenterPanel.AddView(iv, 2dip, 2dip, 32dip, 32dip)
	iv.PickOnBounds = True
	#end if
	#End Region
	
	#If B4J
	xui.SetDataFolder("B4XPagesSQLiteLight2")
	#End If
	
	'copy the default DB
	If File.Exists(xui.DefaultFolder, "jobs.db") = False Then
		File.Copy(File.DirAssets, "jobs.db", xui.DefaultFolder, "jobs.db")
	End If
	
	'initialize the database
	#If B4J
	SQL1.InitializeSQLite(xui.DefaultFolder, "jobs.db", True)
	#Else
	SQL1.Initialize(xui.DefaultFolder, "jobs.db", True)
	#End If
	
	'initialize the ToastMessage class
	ToastMessage.Initialize(Root)

	InitTable
End Sub

#if B4J
Sub imgHamburger_MouseClicked (EventData As MouseEvent)
	Drawer.LeftOpen = True
End Sub
#else if B4i
Private Sub B4XPage_MenuClick (Tag As String)
	If Tag = "hamburger" Then
		Drawer.LeftOpen = Not(Drawer.LeftOpen)
	End If
End Sub
#end if

Private Sub B4XPage_Appear
	ShowTable	
End Sub

Private Sub B4XPage_CloseRequest As ResumableSub
	Dim sf As Object = xui.Msgbox2Async("Do you want to quit ?", "Quit", "Yes", "Cancel", "No", Null)
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		Return True
	End If
	Return False
End Sub

'Shows the database in a table in a B4XTable
Public Sub ShowTable
	Private Query As String

	ReadDataBaseRowIDs
	
	Query = "SELECT FirstName, LastName, City FROM persons"
	'depending if the filter is active or not we add the filter query at the end of the query
	'the filter query is defined in the Filter Activity
	If Filter.flagFilterActive = False Then
		btnFilter.Text = "Filter"
	Else
		btnFilter.Text = "UnFilter"
		Query = Query & Filter.Query
	End If

	Dim Data As List
	Data.Initialize
	Dim rs As ResultSet = SQL1.ExecQuery(Query)
	Do While rs.NextRow
		Dim row(3) As Object
		row(0) = rs.GetString("FirstName")
		row(1) = rs.GetString("LastName")
		row(2) = rs.GetString("City")
		Data.Add(row)
	Loop
	rs.Close
	bxtTable.SetData(Data)
	bxtTable.RefreshNow
	
	UpdateSelectedEntryDisplay
End Sub

Private Sub InitTable
	bxtTable.AddColumn("First name", bxtTable.COLUMN_TYPE_TEXT)
	bxtTable.AddColumn("Last name", bxtTable.COLUMN_TYPE_TEXT)
	bxtTable.AddColumn("City", bxtTable.COLUMN_TYPE_TEXT)
End Sub

Public Sub UpdateSelectedEntryDisplay
	If CurrentIndex > -1 Then
		Private Query As String
		Private ResultSet1 As ResultSet
	
		Query = "SELECT FirstName, LastName FROM persons WHERE rowid = " & RowIDList.Get(CurrentIndex)
		ResultSet1 = SQL1.ExecQuery(Query)
		ResultSet1.NextRow
		lblSelectedItem.Text = ResultSet1.GetString("FirstName") & " " & ResultSet1.GetString("LastName")
		ResultSet1.Close
	Else
		lblSelectedItem.Text = ""
	End If
End Sub

'Reads the database rowids in RowIDList
Private Sub ReadDataBaseRowIDs
	Private ResultSet1 As ResultSet
	
	If Filter.flagFilterActive = False Then
		ResultSet1 = SQL1.ExecQuery("SELECT rowid FROM persons")
	Else
		ResultSet1 = SQL1.ExecQuery("SELECT rowid FROM persons"  & Filter.Query)
	End If
	
	'We read only the rowid column and put them in the IDList
	RowIDList.Initialize				'initialize the ID list
	Do While ResultSet1.NextRow
		RowIDList.Add(ResultSet1.GetInt2(0))		'add the ID's to the ID list
	Loop
	
	If RowIDList.Size > 0 Then
		If CurrentIndex = -1 Or CurrentIndex > RowIDList.Size - 1 Then
			CurrentIndex = 0			'set the current index to 0
		End If
	Else
		CurrentIndex = -1			'set the current index to -1, no selected item
		ToastMessage.Show("No items found")
	End If
	ResultSet1.Close							'close the ResultSet, we don't need it anymore
End Sub


Private Sub btnFilter_Click
	Filter.flagFilterActive = Not(Filter.flagFilterActive)
	ShowTable
End Sub

Private Sub btnSetFilter_Click
	B4XPages.ShowPage("Filter")
End Sub

Private Sub bxtTable_CellClicked (ColumnId As String, RowId As Long)
	CurrentIndex = RowId - 1
	UpdateSelectedEntryDisplay
End Sub

Sub btnEmployee_Click
	Drawer.LeftOpen = False
	B4XPages.ShowPage("Employee")
End Sub

Sub btnCustomer_Click
	Drawer.LeftOpen = False
	B4XPages.ShowPage("Customer")
End Sub

Sub btnJob_Click
	Drawer.LeftOpen = False
	B4XPages.ShowPage("Job")
End Sub

